
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Wallet_transactionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const wallet_transactions = await db.wallet_transactions.create(
            {
                id: data.id || undefined,
        
        direction: data.direction
        ||
        null
            ,
            
        kind: data.kind
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        reference_key: data.reference_key
        ||
        null
            ,
            
        note: data.note
        ||
        null
            ,
            
        occurred_at: data.occurred_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await wallet_transactions.setWallet( data.wallet || null, {
            transaction,
        });
        
        await wallet_transactions.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return wallet_transactions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const wallet_transactionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                direction: item.direction
            ||
            null
            ,
            
                kind: item.kind
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                reference_key: item.reference_key
            ||
            null
            ,
            
                note: item.note
            ||
            null
            ,
            
                occurred_at: item.occurred_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const wallet_transactions = await db.wallet_transactions.bulkCreate(wallet_transactionsData, { transaction });

        // For each item created, replace relation files
        

        return wallet_transactions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const wallet_transactions = await db.wallet_transactions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.direction !== undefined) updatePayload.direction = data.direction;
        
        
        if (data.kind !== undefined) updatePayload.kind = data.kind;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.reference_key !== undefined) updatePayload.reference_key = data.reference_key;
        
        
        if (data.note !== undefined) updatePayload.note = data.note;
        
        
        if (data.occurred_at !== undefined) updatePayload.occurred_at = data.occurred_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await wallet_transactions.update(updatePayload, {transaction});

        
        
        if (data.wallet !== undefined) {
            await wallet_transactions.setWallet(
              
              data.wallet,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await wallet_transactions.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return wallet_transactions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const wallet_transactions = await db.wallet_transactions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of wallet_transactions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of wallet_transactions) {
                await record.destroy({transaction});
            }
        });


        return wallet_transactions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const wallet_transactions = await db.wallet_transactions.findByPk(id, options);

        await wallet_transactions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await wallet_transactions.destroy({
            transaction
        });

        return wallet_transactions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const wallet_transactions = await db.wallet_transactions.findOne(
            { where },
            { transaction },
        );

        if (!wallet_transactions) {
            return wallet_transactions;
        }

        const output = wallet_transactions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.wallet = await wallet_transactions.getWallet({
            transaction
        });
        
        
        output.organizations = await wallet_transactions.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.demo_wallets,
        as: 'wallet',
        
        where: filter.wallet ? {
          [Op.or]: [
            { id: { [Op.in]: filter.wallet.split('|').map(term => Utils.uuid(term)) } },
            {
              currency: {
                [Op.or]: filter.wallet.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.currency) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'wallet_transactions',
                        'currency',
                        filter.currency,
                    ),
                };
            }
            
            if (filter.reference_key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'wallet_transactions',
                        'reference_key',
                        filter.reference_key,
                    ),
                };
            }
            
            if (filter.note) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'wallet_transactions',
                        'note',
                        filter.note,
                    ),
                };
            }
            

            
            

            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.occurred_atRange) {
                const [start, end] = filter.occurred_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    occurred_at: {
                    ...where.occurred_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    occurred_at: {
                    ...where.occurred_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.direction) {
                where = {
                    ...where,
                direction: filter.direction,
            };
            }
            
            if (filter.kind) {
                where = {
                    ...where,
                kind: filter.kind,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.wallet_transactions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'wallet_transactions',
                        'reference_key',
                        query,
                    ),
                ],
            };
        }

        const records = await db.wallet_transactions.findAll({
            attributes: [ 'id', 'reference_key' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['reference_key', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.reference_key,
        }));
    }

    
};

